## API Report File for "@fluentui/react-avatar"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import type { ComponentProps } from '@fluentui/react-utilities';
import type { ComponentState } from '@fluentui/react-utilities';
import type { ForwardRefComponent } from '@fluentui/react-utilities';
import type { IntrinsicShorthandProps } from '@fluentui/react-utilities';
import type { ObjectShorthandProps } from '@fluentui/react-utilities';
import type { PresenceBadgeProps } from '@fluentui/react-badge';
import * as React_2 from 'react';
import type { ShorthandRenderFunction } from '@fluentui/react-utilities';

// @public (undocumented)
export const Avatar: ForwardRefComponent<AvatarProps>;

// @public (undocumented)
export type AvatarCommons = Omit<React_2.HTMLAttributes<HTMLElement>, 'children'> & {
    name: string;
    getInitials: (name: string, isRtl: boolean) => string;
    size: 20 | 24 | 28 | 32 | 36 | 40 | 48 | 56 | 64 | 72 | 96 | 120 | 128;
    shape: 'circular' | 'square';
    active: 'active' | 'inactive' | 'unset';
    activeAppearance: 'ring' | 'shadow' | 'glow' | 'ring-shadow' | 'ring-glow';
    color: 'neutral' | 'brand' | 'colorful' | AvatarNamedColor;
    idForColor: string | undefined;
};

// @public
export type AvatarNamedColor = 'darkRed' | 'cranberry' | 'red' | 'pumpkin' | 'peach' | 'marigold' | 'gold' | 'brass' | 'brown' | 'forest' | 'seafoam' | 'darkGreen' | 'lightTeal' | 'teal' | 'steel' | 'blue' | 'royalBlue' | 'cornflower' | 'navy' | 'lavender' | 'purple' | 'grape' | 'lilac' | 'pink' | 'magenta' | 'plum' | 'beige' | 'mink' | 'platinum' | 'anchor';

// @public
export type AvatarProps = Omit<ComponentProps<AvatarSlots>, 'image'> & Partial<AvatarCommons> & {
    image?: Omit<IntrinsicShorthandProps<'img'>, 'children'> & {
        children?: ShorthandRenderFunction<React_2.HTMLAttributes<HTMLImageElement>>;
    };
};

// @public (undocumented)
export type AvatarSlots = {
    root: Omit<IntrinsicShorthandProps<'span'>, 'color'> & {
        children?: never;
    };
    image?: IntrinsicShorthandProps<'img'>;
    label?: IntrinsicShorthandProps<'span'>;
    icon?: IntrinsicShorthandProps<'span'>;
    badge?: ObjectShorthandProps<PresenceBadgeProps>;
};

// @public
export type AvatarState = ComponentState<AvatarSlots> & AvatarCommons & {
    color: Exclude<AvatarCommons['color'], 'colorful'>;
};

// @public (undocumented)
export const renderAvatar: (state: AvatarState) => JSX.Element;

// @public (undocumented)
export const useAvatar: (props: AvatarProps, ref: React_2.Ref<HTMLElement>) => AvatarState;

// @public (undocumented)
export const useAvatarStyles: (state: AvatarState) => AvatarState;

// (No @packageDocumentation comment for this package)

```
